/**
 * @file ManageThread.cpp
 * @date 2010/02/20 新規作成
 * @author
 *
 * Thread管理クラス
 */
#include <stdlib.h>
#include <sys/unistd.h>
#include "Define.h"
#include "ManageThread.h"

void *command_thread(void *argument){
	int returnValue = EXIT_SUCCESS;
	CommandThreadStruct *ManageThreadstruct = (CommandThreadStruct*)argument;

	ManageThreadstruct->isBegun = true;
	std::vector<std::string>::iterator iterator;
	chdir(ManageThreadstruct->commandDirectory.c_str());
	for(iterator = ManageThreadstruct->commandString.begin();
			iterator != ManageThreadstruct->commandString.end();
			iterator++){
		system(iterator->c_str());
	}
	ManageThreadstruct->commandString.clear();
	ManageThreadstruct->isEnded = true;
	pthread_exit(&returnValue);
}

/**
 * デフォルトコンストラクタ
 */
ManageThread::ManageThread(){
}

/**
 * m_CommandThreadStructメンバの取得
 * @return m_CommandThreadStructメンバ
 */
TCommandThreadStruct& ManageThread::getData(){
	return m_CommandThreadStruct;
}

/**
 * m_ControlThreadメンバの取得
 * @return m_ControlThreadメンバ
 */
ControlThread& ManageThread::getControlThread(){
	return m_ControlThread;
}

/**
 * nandlogical実行
 * @return 処理結果 OK/NG
 */
ReturnValue ManageThread::run(){
	m_CommandThreadStruct.getData().isBegun = false;
	m_CommandThreadStruct.getData().isEnded = false;
	m_ControlThread.begin(command_thread, &m_CommandThreadStruct);
	return OK;
}
