/**
 * @file MkimageString.cpp
 * @date 2010/03/07 新規作成
 * @author
 *
 * mkimageコマンド文字列作成クラス
 */

#include <cstdlib>
#include <fstream>
#include <string>
#include "Define.h"
#include "MkimageString.h"

/**
 * デフォルトコンストラクタ
 */
MkimageString::MkimageString(){
	m_FirstHalf = "mkimage -A arm -O linux -T kernel -C none ";
#ifdef TEST
	m_LastHalf = " -n \"Linux2.4\" -d zImage uImage";
#else
	m_LastHalf = " -n \"Linux2.4\" -d zImage uImage > /dev/null";
#endif
	m_Filename = "/proc/deviceinfo/product";
}

/**
 * テスト用（テスト時に読み込みファイル変更するため）
 */
#ifdef TEST
ReturnValue MkimageString::setFilename(std::string filename){
	m_Filename = filename;
	return OK;
}
#endif

/**
 * コマンド文字列作成
 */
ReturnValue MkimageString::factory(std::string& command_string)
{
	std::ifstream inputStream;
	char buffer[256];

	inputStream.open(m_Filename.c_str());
	if( !inputStream.is_open() ){
		return NG;
	}
	inputStream.getline(buffer, sizeof(buffer));
	inputStream.close();
	command_string = m_FirstHalf;
	switch(m_CheckProduct.check(buffer)){
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
		command_string += "-a 0xa0008000 -e 0xa0008000";
		break;
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
		command_string += "-a 0xa0008000 -e 0xa0008000";
		break;
	case SL_NONE :
	default :
		command_string = "";
		return NG;
	}
	command_string += m_LastHalf;

	return OK;
}
