/**
 * @file NandlogicalString.cpp
 * @date 2010/03/07 新規作成
 * @author
 *
 * nandlogicalコマンド文字列作成クラス
 */

#include <cstdlib>
#include <fstream>
#include <string>
#include "Define.h"
#include "NandlogicalString.h"

/**
 * デフォルトコンストラクタ
 */
NandlogicalString::NandlogicalString(){
	m_FirstHalf = "nandlogical /dev/mtd1 READ ";
#ifdef TEST
	m_LastHalf = " zImage";
#else
	m_LastHalf = " zImage > /dev/null";
#endif
	m_Filename = "/proc/deviceinfo/product";
}

/**
 * テスト用（テスト時に読み込みファイル変更するため）
 */
#ifdef TEST
ReturnValue NandlogicalString::setFilename(std::string filename){
	m_Filename = filename;
	return OK;
}
#endif

/**
 * コマンド文字列作成
 */
ReturnValue NandlogicalString::factory(std::string& command_string)
{
	std::ifstream inputStream;
	char buffer[256];

	inputStream.open(m_Filename.c_str());
	if( !inputStream.is_open() ){
		return NG;
	}
	inputStream.getline(buffer, sizeof(buffer));
	inputStream.close();
	command_string = m_FirstHalf;
	switch(m_CheckProduct.check(buffer)){
	case SL_C3200 :
	case SL_C3100 :
	case SL_C3000 :
	case SL_C1000 :
		command_string += "0xe0000 0x13BFEF";
		break;
	case SL_C860 :
	case SL_C760 :
	case SL_C750 :
	case SL_C700 :
		command_string += "0xe0000 0x13BFFF";
		break;
	case SL_NONE :
	default :
		command_string = "";
		return NG;
	}
	command_string += m_LastHalf;

	return OK;
}
