/**
 * @file RunCommand.cpp
 * @date 2010/02/20 新規作成
 * @author
 *
 * コマンド実行クラス
 */
#include "Define.h"
#include "RunCommand.h"

/**
 * デフォルトコンストラクタ
 */
RunCommand::RunCommand(){
}

/**
 * m_ManageThreadメンバの取得
 * @return m_ManageThreadメンバ
 */
ManageThread& RunCommand::getManageThread(){
	return m_ManageThread;
}

/**
 * m_NandlogicalStringメンバの取得
 * @return m_NandlogicalStringメンバ
 */
#ifdef TEST
NandlogicalString& RunCommand::getNandlogicalString(){
	return m_NandlogicalString;
}
#endif

/**
 * m_MkimageStringメンバの取得
 * @return m_MkimageStringメンバ
 */
#ifdef TEST
MkimageString& RunCommand::getMkimageString(){
	return m_MkimageString;
}
#endif

/**
 * コマンド実行
 * @return 処理結果 OK/NG
 */
ReturnValue RunCommand::runCommand(std::string directory){
	std::string command_string;
	m_ManageThread.getData().getData().commandDirectory = directory;
	if( m_NandlogicalString.factory(command_string) == OK ){
		m_ManageThread.getData().getData().commandString.push_back(command_string);
	}else{
		return NG;
	}
	if( m_MkimageString.factory(command_string) == OK ){
		m_ManageThread.getData().getData().commandString.push_back(command_string);
	}else{
		return NG;
	}
	return m_ManageThread.run();
}

